package com.madeu.controller.mobile.mobilenotice;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobilenotice.MobileNoticeService;
import com.madeu.service.web.webhome.WebHomeService;
import com.madeu.service.web.webmenu.WebMenuService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;


@Slf4j
@Controller
public class MobileNoticeController extends ManagerDraftAction{

    @Autowired
    private MobileNoticeService mobileNoticeService;

    /**
     * 공지사항 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/mobilenotice/selectNoticeIntro.do")
    public String  noticeIntro(HttpSession session,HttpServletRequest request, Model model) {
        log.debug("MobileNoticeController  noticeIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try {
            if (!mobileCheckLogin(session)) {
                return "/mobile/login/login";
            } else {
            }
        } catch (Exception e) {
            e.printStackTrace();
            return "/mobile/login/login";
        }
        log.debug("MobileNoticeController  selectNoticeIntro END");
        return "/mobile/notice/selectListNotice";
    }

    /**
     * 앱 공지사항 정보 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/mobilenotice/selectListNotice.do")
    public ModelAndView selectListAppNotice(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("MobileNoticeController selectListAppNotice START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!mobileCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = mobileNoticeService.selectListNotice(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("MobileNoticeController selectListNotice END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 엡 공지사항 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/mobilenotice/selectNotice.do")
    public ModelAndView selectAppNotice(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("MobileNoticeController selectNotice START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            if(!mobileCheckLogin(session)){
                return null;
            }
            else{
                paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
                map = mobileNoticeService.selectNotice(paramMap);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("MobileNoticeController selectNotice END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}